local LDBThreat = LibStub("LibDataBroker-1.1"):NewDataObject("LDBThreat", { icon = "Interface\\TARGETINGFRAME\\UI-TargetingFrame-Skull.blp", type = "data source", text = "" })

local f = CreateFrame("Frame")

f:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE")
f:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
f:RegisterEvent("PLAYER_TARGET_CHANGED")
f:RegisterEvent("PARTY_MEMBERS_CHANGED")
f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

local Color = {green = "ff00ff00", blue = "ff00ffff", red = "ffff0000", yellow = "ffffff00", orange = "ffffa500",}

local fademiActive = fademiActive -- set values
local tempthreat = {}--tempthreat -- set values
local currenttarget = currenttarget -- set values

local function StoreThreat()
local _, _, _, _, threatvalue = UnitDetailedThreatSituation("player", "target")
	if threatvalue then
		if threatvalue > 1 then
			lastthreat = threatvalue
		elseif not threatvalue then
			lastthreat = 0
		end
	end
return lastthreat
end

local function GetThreat(unitId, mobId)
	local _, _, _, rawthreatpct, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not rawthreatpct then rawthreatpct = 0 end
	return rawthreatpct
end

local function GetThreatValue(unitId, mobId)
	local _, _, _, _, threatvalue = UnitDetailedThreatSituation(unitId, mobId)
	if not threatvalue then threatvalue = 0 end
	return threatvalue
end

local function GetThreatStatus(unitId, mobId)
	local _,status,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	return status
end

local function GetTank(unitId, mobId)
	local isTanking,_,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not isTanking then isTanking = 0 end
	return isTanking
end

local function GetClassColor(unit)
	local unitClass, englishClass = UnitClass(unit)
	local classColor = "ff848484" --Pets
	if englishClass == "DEATHKNIGHT" then
		classColor = "ffC41F3B"
		
	elseif englishClass == "DRUID" then
		classColor = "ffFF7D0A"
	
	elseif englishClass == "HUNTER" then
		classColor = "ffABD473"
	
	elseif englishClass == "MAGE" then
		classColor = "ff69CCF0"
	
	elseif englishClass == "PALADIN" then
		classColor = "ffF58CBA"
	
	elseif englishClass == "PRIEST" then
		classColor = "ffFFFFFF"
	
	elseif englishClass == "ROGUE" then
		classColor = "ffFFF569"
	
	elseif englishClass == "SHAMAN" then
		classColor = "ff2459FF"
	
	elseif englishClass == "WARLOCK" then
		classColor = "ff9482C9"
	
	elseif englishClass == "WARRIOR" then
		classColor = "ffC79C6E"
	end
	return classColor
end

local function UpdateDisplay()
	LDBThreat.text = "LDB-Threat"
	local status = nil
	local highUnit = ""
	local unitThreat = 0
	local highThreat = 0
	local tankName = nil
	local unitThreatValue = 0
	local playerThreatValue = 0
	local partynum = GetNumPartyMembers()
	local raidnum = GetNumRaidMembers()
	if (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "target") and not(UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) -- Solo Target
	then			
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		if HasPetUI() then
			unitThreatValue = GetThreatValue("pet", "target")
			highThreat = GetThreat("pet", "target")
			highUnit = UnitName("pet")
			highUnitColor = GetClassColor("pet")
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) -- Solo Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")			
		playerThreatValue = GetThreatValue("player", "targettarget")
		if HasPetUI() then
			unitThreatValue = GetThreatValue("pet", "targettarget")
			highThreat = GetThreat("pet", "targettarget")
			highUnit = UnitName("pet")
			highUnitColor = GetClassColor("pet")
			unitTanking = GetTank("pet", "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) --Raid Target
	then 
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "target") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raid"..i)
					highUnitColor = GetClassColor("raid"..i)
					unitThreatValue = GetThreatValue("raid"..i, "target")
				end
			unitThreat = GetThreat("raidpet"..i, "target")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raidpet"..i)
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("raidpet"..i, "target")
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "target")
				end
			unitTanking = GetTank("raid"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raid"..i)
				tankName = UnitName("raid"..i)
			end
			unitTanking = GetTank("raidpet"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raidpet"..i)
				tankName = UnitName("raidpet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) --Raid Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")
		playerThreatValue = GetThreatValue("player", "targettarget")
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "targettarget") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raid"..i)
					highUnitColor = GetClassColor("raid"..i)
					unitThreatValue = GetThreatValue("raid"..i, "targettarget")
				end
			unitThreat = GetThreat("raidpet"..i, "targettarget")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raidpet"..i)
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("raidpet"..i, "targettarget")
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "targettarget")
				end
			unitTanking = GetTank("raid"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raid"..i)
				tankName = UnitName("raid"..i)
			end
			unitTanking = GetTank("raidpet"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raidpet"..i)
				tankName = UnitName("raidpet"..i)
			end
			unitTanking = GetTank("pet", "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) -- Party Target
	then 
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "target") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("party"..i)
					highUnitColor = GetClassColor("party"..i)
					unitThreatValue = GetThreatValue("party"..i, "target")
				end
			unitThreat = GetThreat("partypet"..i, "target")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("partypet"..i)
					highUnitColor = GetClassColor("partypet"..i)
					unitThreatValue = GetThreatValue("partypet"..i, "target")
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "target")
				end
			unitTanking = GetTank("party"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("party"..i)
				tankName = UnitName("party"..i)
			end
			unitTanking = GetTank("partypet"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("partypet"..i)
				tankName = UnitName("partypet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) --Party Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")	
		playerThreatValue = GetThreatValue("player", "targettarget")
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "targettarget") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("party"..i)
					highUnitColor = GetClassColor("party"..i)
					unitThreatValue = GetThreatValue("party"..i, "targettarget")
				end
			unitThreat = GetThreat("partypet"..i, "targettarget")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("partypet"..i)
					highUnitColor = GetClassColor("partypet"..i)
					unitThreatValue = GetThreatValue("partypet"..i, "targettarget")
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "targettarget")
				end
			unitTanking = GetTank("party"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("party"..i)
				tankName = UnitName("party"..i)
			end
			unitTanking = GetTank("partypet"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("partypet"..i)
				tankName = UnitName("partypet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	end
	if status then
		StoreThreat()
	end
	if status == 0
	then
		if rawthreatpct < 80
		then
			LDBThreat.text = string.format("|c%s%d %%|r", Color.green, rawthreatpct )
			if tankName
			then
				threatValuediff = ((unitThreatValue - playerThreatValue) / 100000 )
				LDBThreat.text = string.format("|c%s%2.1fk | %d %% <|r |c%s%s.|r", Color.green, threatValuediff, rawthreatpct, unitTankingColor, tankName )
				if currenttarget then -- display temporary threat 
					threatValuediff = ((unitThreatValue - currenttarget) / 100000 )
					tempthreatpct = floor((currenttarget / unitThreatValue) * 100)
					LDBThreat.text = string.format("|c%s%2.1fk | %d %% <|r |c%s%s.|r", Color.blue, threatValuediff, tempthreatpct, unitTankingColor, tankName )
				end
			end
		end
		if rawthreatpct > 79 and rawthreatpct < 100
		then
			LDBThreat.text = string.format("|c%s%d %%|r", Color.yellow, rawthreatpct )
			if tankName
			then
				threatValuediff = ((unitThreatValue - playerThreatValue) / 100000 )
				LDBThreat.text = string.format("|c%s%2.1fk | %d %% <|r |c%s%s.|r", Color.yellow, threatValuediff, rawthreatpct, unitTankingColor, tankName )
				if currenttarget then -- display temporary threat 
					threatValuediff = ((unitThreatValue - currenttarget) / 100000 )
					tempthreatpct = floor((currenttarget / unitThreatValue) * 100)
					LDBThreat.text = string.format("|c%s%2.1fk | %d %% <|r |c%s%s.|r", Color.blue, threatValuediff, tempthreatpct, unitTankingColor, tankName )
				end
			end
		end
	elseif status == 1
	then
		LDBThreat.text = string.format("|c%s%d %%|r", Color.yellow, rawthreatpct )
		if tankName
		then
			threatValuediff = ((unitThreatValue - playerThreatValue) / 100000 )
			LDBThreat.text = string.format("|c%s%2.1fk | %d %% >|r |c%s%s.|r", Color.yellow, threatValuediff, rawthreatpct, unitTankingColor, tankName )
			if currenttarget then -- display temporary threat 
				threatValuediff = ((unitThreatValue - currenttarget) / 100000 )
				tempthreatpct = floor((currenttarget / unitThreatValue) * 100)
				LDBThreat.text = string.format("|c%s%2.1fk | %d %% <|r |c%s%s.|r", Color.blue, threatValuediff, tempthreatpct, unitTankingColor, tankName )
			end
		end
	elseif status == 2
	then
		LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.orange )
		if highThreat ~= 0
		then
			threatValuediff = ((playerThreatValue - unitThreatValue) / 100000 )
			threatdiff = (100 - highThreat)
			LDBThreat.text = string.format("|c%s%2.1fk | %d %% >|r |c%s%s.|r", Color.orange, threatValuediff, threatdiff, highUnitColor, highUnit )
			if currenttarget then -- display temporary threat 
				threatValuediff = ((currenttarget - unitThreatValue) / 100000 )
				threatdiff = (100 - highThreat)
				LDBThreat.text = string.format("|c%s%2.1fk | %d %% >|r |c%s%s.|r", Color.orange, threatValuediff, threatdiff, highUnitColor, highUnit )
			end
		end	
	elseif status == 3
	then
		LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.red )
		if highThreat ~= 0
		then
			threatValuediff = ((playerThreatValue - unitThreatValue) / 100000)
			threatdiff = (100 - highThreat)
			LDBThreat.text = string.format("|c%s%2.1fk | %d %% >|r |c%s%s.|r", Color.red, threatValuediff, threatdiff, highUnitColor, highUnit )
			if currenttarget then -- display temporary threat 
				threatValuediff = ((currenttarget - unitThreatValue) / 100000 )
				threatdiff = (100 - highThreat)
				LDBThreat.text = string.format("|c%s%2.1fk | %d %% >|r |c%s%s.|r", Color.red, threatValuediff, threatdiff, highUnitColor, highUnit )
			end
		end
	end
end

function LDBThreat:OnTooltipShow()
	self:AddLine("LDB-Threat |cff00ff004.6|r")
end

local function tContains(table, item)
       local index = 1;
       while table[index] do
               if ( item == table[index] ) then
                       return 1;
               end
               index = index + 1;
       end
       return nil;
end

local function eventHandler(self, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local timestamp, eventtype, hideCaster, srcGUID, srcName, srcFlags, srcFlags2, dstGUID, dstName, dstFlags, dstFlags2 = ...
		local targetGUID = UnitGUID("target")
		local damage
		local playerGUID = UnitGUID("player")
		if srcGUID == playerGUID then
		if eventtype == "SPELL_AURA_APPLIED" then
			local spellID = select(12, ...)
			if spellID == 55342 or spellID == 586 --[[or spellID == 1038]] then
				--DEFAULT_CHAT_FRAME:AddMessage("Temp spell casted") --debug message
				fademiActive = true
				if StoreThreat() > 0 then -- has a threat value
					tempthreat[targetGUID] = StoreThreat()			-- set temp threat to last known threat value
					currenttarget = StoreThreat()
					--DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00test:|r tempthreat set to storethreat|cff00ff00 %s|r", tempthreat )) -- debug message
				end
			end
		elseif eventtype == "SPELL_DAMAGE" or eventtype == "RANGE_DAMAGE" or eventtype == "SPELL_PERIODIC_DAMAGE" then
			if fademiActive == true then
			--DEFAULT_CHAT_FRAME:AddMessage("Detecting damage") --debug message
			damage = select(15, ...)
			
			end
		elseif eventtype == "SWING_DAMAGE" then
			if fademiActive == true then
			damage = select(12, ...)
			
			end
		elseif eventtype == "SPELL_AURA_REMOVED" then
			local spellID = select(12, ...)
			if spellID == 55342 or spellID == 586 --[[or spellID == 1038]] then
				--DEFAULT_CHAT_FRAME:AddMessage("Temp spell expired") --debug message
				wipe(tempthreat) -- clear table
				damage = nil
				fademiActive = nil
				currenttarget = nil
			end	
		end
		if damage then
			tempthreat[dstGUID] = (tempthreat[dstGUID] or 0) + damage * 100
			currenttarget = tempthreat[dstGUID]
		end
		end
	elseif event == "PLAYER_TARGET_CHANGED" then
		local targetGUID = UnitGUID("target")
		if fademiActive == true then
			local intable = tContains(tempthreat, targetGUID)
			if not intable then
				currenttarget = nil
				--DEFAULT_CHAT_FRAME:AddMessage("currentarget set to nil") -- debug message
			end
			for index,value in pairs(tempthreat) do 
				if targetGUID == index then
					currenttarget = value
					--DEFAULT_CHAT_FRAME:AddMessage(tostring(index).." : "..tostring(value)) -- debug message
				
				end
			
			end
		end

		UpdateDisplay()
	else
		UpdateDisplay()
	end
end
f:SetScript("OnEvent", eventHandler)